Last Comment Bug 340957 - duplicate messages from single feed item if using multiple RSS accounts
: duplicate messages from single feed item if using multiple RSS accounts
Status: RESOLVED FIXED
[patch]
: fixed1.8.1.2
Product: MailNews Core
Classification: Components
Component: Feed Reader (show other bugs)
: unspecified
: All All
: P2 major with 3 votes (vote)
: ---
Assigned To: David Baron :dbaron: ⌚️UTC+2 (mostly busy through August 4; review requests must explain patch)
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2006-06-09 06:39 PDT by Pierre Goiffon
Modified: 2009-05-05 00:47 PDT (History)
6 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
1st OPML file used (885 bytes, application/octet-stream)
2006-06-09 06:40 PDT, Pierre Goiffon
no flags Details
2nd OPML file used (573 bytes, application/octet-stream)
2006-06-09 06:40 PDT, Pierre Goiffon
no flags Details
3rd OPML file used (1.81 KB, application/octet-stream)
2006-06-09 06:41 PDT, Pierre Goiffon
no flags Details
patch (2.98 KB, patch)
2006-12-24 18:40 PST, David Baron :dbaron: ⌚️UTC+2 (mostly busy through August 4; review requests must explain patch)
mscott: review+
Details | Diff | Splinter Review

Description Pierre Goiffon 2006-06-09 06:39:19 PDT
User-Agent:       Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.0.4) Gecko/20060508 Firefox/1.5.0.4
Build Identifier: version 1.5.0.4 (20060516)

In order to get categories for RSS feeds, I created 3 different RSS accounts. In this configuration, 2 annoying problems appears :
- many times the entries are re-download, and so appears twice in feeds
- no support for the "show the article summary" option (always show the web page)

First I was thinking this problem was maybe caused by the antivirus software (Norton Antivirus 9.0.0.338), but disabling it didn't worked. So I export all the accounts in OPML files, delete them, recreate one account and import the OPML files. Since then, everything works as expected.

Reproducible: Always

Steps to Reproduce:
1. Create one RSS account
2. Add RSS feeds to it (directly in the acount settings windows or in 2 steps, closing the account settings windows then open the manage subscription link in the account context menu)
3. repeat steps 1 and 2 to create 2 or more RSS accounts
4. close Thunderbird, open it : the RSS fees articles are retrieved. Mark them as read
5. close Thunderbird, open it : for some RSS feeds certains articles already presents in thunderbird are downloaded again

Actual Results:  
- Duplicates entry in RSS feeds
- Always display the article web page instead of the summary whereas the appropriate option is checked or not
Comment 1 Pierre Goiffon 2006-06-09 06:40:14 PDT
Created attachment 224998 [details]
1st OPML file used
Comment 2 Pierre Goiffon 2006-06-09 06:40:41 PDT
Created attachment 224999 [details]
2nd OPML file used
Comment 3 Pierre Goiffon 2006-06-09 06:41:01 PDT
Created attachment 225000 [details]
3rd OPML file used
Comment 4 salsa_43 2006-10-24 11:43:31 PDT
I am having this exact same problem.  I have multiple RSS feeds in one account and  occassionally I get all the previously read entries duplicated and marked as new.  I think it primarily happens after I add/remove feeds.  

This is happening in 1.5.0.7 and also in earlier versions.  
Comment 5 David Baron :dbaron: ⌚️UTC+2 (mostly busy through August 4; review requests must explain patch) 2006-12-22 15:18:24 PST
I'd actually written up a bug report about this same problem before finding this one, so confirming.  (I'd concentrated my report on the multiple messages problem, although I also see problems with "Show the article summary instead of loading the Web page".)  I'd also note that the multiple messages problem seems to show up in situations where we're processing feeds in different accounts at the same time.  The report I'd written was the following:


Thunderbird feed downloading tends to get confused about what feed items are new and what have been already downloaded when it's downloading feeds in two *accounts* simultaneously.  I've noticed this problem quite a bit in various situations while using both Thunderbird 1.5.0.x and Thunderbird 2.0b1 -- I have my RSS Feeds grouped into 5 separate accounts (with one folder per feed).

My suspicion is that the problem is related to downloading feeds in multiple accounts at the same time.  When I explicitly get new messages on the accounts so they're not downloading at the same time, I don't see the problem.

The steps to reproduce below are the most reliable way I've found to reproduce the problem.  (I'd been testing most of the time with feeds behind HTTP auth, without saving the passwords, since I thought that would make it even more reliable.  However, it seems to be reliable even without that.)  These steps show the problem 100% of the time for me, whereas in general the problem is rather intermittent (and annoying), since I'm not always downloading messages for multiple accounts at the same time.

Steps to reproduce:
 1. Start Thunderbird 2.0 beta 1 on a clean profile
 2. when the account manager comes up, create a RSS News & Blogs
    account (accept all defaults)
 3. File -> New -> Account, and create a *second* RSS News & Blogs
    account.  (Call this one something else.)
 4. Right click on each accounts in the folder pane, select
    "Properties", and change the "100" (check for new messages every) to
    "1".
 5. Right click on the first account in the folder pane, click
    subscribe, click add, and add a feed.
 6. Do the same in the other account, for another feed.
 7. Quit thunderbird
 8. Start thunderbird again.
 9. click on the one folder in each account in the minute before
    thunderbird checks for messages (because check for new messages at
    startup doesn't actually work, so you have to wait for the one
    minute delay), and press Shift-C to mark all the messages in the
    account as read so it's easy to see what gets newly downloaded.
 10. wait 1 minute for Thunderbird to check for new messages (in both
     feeds)

Actual results:  All the articles currently in the feed that was
downloaded second (I think it's the one downloaded second based on my
testing with HTTP auth -- in which case it's the one whose auth dialog
comes up second) get re-downloaded, even though you've already
downloaded them once, so that you have duplicate email (one read thanks
to the mark-all-read in step 9), and one unread).

Expected results:  No duplicate messages created by checking feeds.
Comment 6 David Baron :dbaron: ⌚️UTC+2 (mostly busy through August 4; review requests must explain patch) 2006-12-24 18:40:06 PST
Created attachment 249603 [details] [diff] [review]
patch

So when looking at the feeds.rdf and feeditems.rdf files in the accounts in my profile, I've noticed a lot of entries in those files for feeds that belong to other accounts.  Then, looking around the code, I found this problem.  I haven't yet had a chance to test whether it fixes the problems -- and if so, I'm not sure what it would do to existing profiles with multiple accounts.

I'll try to test this today or tomorrow...
Comment 7 David Baron :dbaron: ⌚️UTC+2 (mostly busy through August 4; review requests must explain patch) 2006-12-25 09:49:00 PST
Comment on attachment 249603 [details] [diff] [review]
patch

This does fix the problem (tested in a 1.8 branch build, using the steps in comment 5).

I haven't tried it on my existing profile yet -- I'm not sure how it will react to the already-corrupted RDF files -- whether things will be worse, the same, or better.  But I think we probably do want to fix this either way.
Comment 8 Scott MacGregor 2006-12-27 14:38:07 PST
Comment on attachment 249603 [details] [diff] [review]
patch

thanks a lot David.
Comment 9 David Baron :dbaron: ⌚️UTC+2 (mostly busy through August 4; review requests must explain patch) 2006-12-27 16:30:08 PST
Checked in to trunk and MOZILLA_1_8_BRANCH.
Comment 10 Alvin Brinson 2007-02-21 06:09:02 PST
This was not fixed in Beta 2 as claimed. I am experiencing this behaviour in Beta 2 build 20070116.
Comment 11 Alvin Brinson 2007-02-21 06:13:16 PST
Okay, maybe this exact bug was fixed, as I am only using a single RSS account, but with subfolders. However, duplicate entries do still show up - am searching for the correct bug to vote for. My bad.
Comment 12 franck 2008-09-24 05:35:17 PDT
I still have this problem with Thunderbird 2.0.0.16 : Duplicate entries still show up for some RSS feed, for exemple this one : http://ditwww.epfl.ch/EPFLTV/RSS/rss_lastentries_f.xml

Could it be a server problem now ?
Comment 13 David Baron :dbaron: ⌚️UTC+2 (mostly busy through August 4; review requests must explain patch) 2008-09-24 07:16:58 PDT
There are certainly other reasons for duplicate messages; it's better to track them in separate bugs.

Note You need to log in before you can comment on or make changes to this bug.